<template>
  <v-menu
    ref="menu"
    :close-on-content-click="false"
    v-model="menu"
    transition="scale-transition"
    offset-y
    min-width="300px"
    :return-value.sync="date"
  >
    <template v-slot:activator="{ on }">
      <v-text-field
        v-on="on"
        :dense="dense"
        :label="label"
        :value="displayDate"
        hide-details
        readonly
        filled
      ></v-text-field>
    </template>

    <v-date-picker v-model="date" no-title scrollable>
      <v-spacer v-if="!isClosingOnSelect"></v-spacer>
      <v-btn v-if="!isClosingOnSelect" text color="primary" @click="menu = false">Cancel</v-btn>
      <v-btn v-if="!isClosingOnSelect" text color="primary" @click="$refs.menu.save(date)">OK</v-btn>
    </v-date-picker>
  </v-menu>
</template>

<script>
import dayjs from "dayjs";

export default {
  props: {
    value: String,
    label: String,
    isClosingOnSelect: Boolean,
    dense: {
      type: Boolean,
      default: false,
    },
  },

  name: "DatePicker",

  data() {
    return {
      menu: false,
    };
  },

  computed: {
    displayDate() {
      return this.value ? dayjs(this.value).format("DD.MM.YYYY") : "Kein Datum ausgewählt";
    },
    date: {
      get: function get() {
        return this.value;
      },
      set: function set(value) {
        const date = dayjs(value).toISOString();
        this.$emit("input", date);

        if (this.isClosingOnSelect) {
          this.$refs.menu.save(date);
        }
      },
    },
  },
};
</script>
